| Web Services for Remote Management 14.0 Reference documentation for web service interfaces to support remote management of Symantec Endpoint Protection

- Home
- Packages
- Classes

- Class List
- Class Hierarchy
- Class Members

List of all members | Public Member Functions
com.symantec.sepm.webservice.client.command.CommandService Interface Reference

The CommandService API provides functionality for running commands on lists of Symantec Endpoint Protection client computers. More...

Inheritance diagram for com.symantec.sepm.webservice.client.command.CommandService:

## Public Member Functions
CommandClientResult | runClientCommandScan (@WebParam(name="computerGUIDList") String[] computerGUIDList,@WebParam(name="scanType") String scanType) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Runs the Scan command on a specified list of client computers. More...
CommandClientResult | runClientCommandEnableNTP (@WebParam(name="computerGUIDList") String[] computerGUIDList) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Enables Network Threat Protection on a specified list of client computers. More...
CommandClientResult | runClientCommandDisableNTP (@WebParam(name="computerGUIDList") String[] computerGUIDList,@WebParam(name="timelimit") long timeLimit) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Disables Network Threat Protection on a specified list of client computers. More...
CommandClientResult | runClientCommandUpdateContent (@WebParam(name="computerGUIDList") String[] computerGUIDList) throws ServiceException, InvalidArgumentServiceException, InsufficientAccessServiceException
| Runs the Update Content command on a specified list of client computers. More...
CommandClientResult | runClientCommandUpdateContentAndScan (@WebParam(name="computerGUIDList") String[] computerGUIDList,@WebParam(name="scanType") String scanType) throws ServiceException, InvalidArgumentServiceException, InsufficientAccessServiceException
| Runs the Update Content and Scan command on a specified list of client computers. More...
CommandClientResult | runClientCommandEnableAP (@WebParam(name="computerGUIDList") String[] computerGUIDList) throws ServiceException, InvalidArgumentServiceException, InsufficientAccessServiceException
| Enables Auto-Protect on a specified list of client computers. More...
CommandClientResult | runClientCommandEnableDownloadInsight (@WebParam(name="computerGUIDList") String[] computerGUIDList) throws ServiceException, InvalidArgumentServiceException, InsufficientAccessServiceException
| Enables Download Insight on a specified list of client computers. More...
CommandClientResult | runClientCommandDisableDownloadInsight (@WebParam(name="computerGUIDList") String[] computerGUIDList,@WebParam(name="timeLimit") long timeLimit) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Disables Download Insight on a specified list of client computers. More...
CommandClientResult | runClientCommandPowerEraser (@WebParam(name="command") PowerEraserCommand command) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Runs an individual PowerEraser command on a specified list of client computers or a list of client groups. More...
CommandClientResult | runClientCommandEvidenceOfCompromise (@WebParam(name="command") EvidenceOfCompromiseCommand command) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Runs an individual Evidence of Compromise (EOC) command on a specified list of client computers or a list of client groups. More...
CommandClientResult | runClientCommandQuarantine (@WebParam(name="command") QuarantineCommand command) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Runs an individual Quarantine command on a specified list of client computers or a list of client groups. More...
CommandStatusDetailResult | getCommandStatusDetails (@WebParam(name="commandID") String commandID,@WebParam(name="pagingOptions") PagingOptions pagingOptions,@WebParam(name="context") Context context) throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException
| Gets detailed information about the status of a specified command for all clients on which the command was run. More...
PagingOptions | createPagingOptions ()
| Creates a PagingOptions object. More...
Context | createContext ()
| Creates a Context object. More...

## Detailed Description

The CommandService API provides functionality for running commands on lists of Symantec Endpoint Protection client computers.

The methods of this API take a list of computer GUIDs that are generated by the methods of the ClientService API.

See also
  ClientService

Most of the methods of this API are used to run individual commands, such as Scan, Update, or enable/disable a protection technology. The getCommandStatusDetails method returns a CommandStatusDetailResult object that provides detailed information about the status of a specified command. This CommandStatusDetailResult object also contains a list of child objects that provide detailed information about the status of the command on each client in the list.

This API also includes methods to create a default PagingOptions object and a default Context object. These objects may be useful if you write your web service calls in PowerShell or another scripting language. Developers who use higher-level languages should be able to create these objects directly, or they can use these helper methods.

See also
  PagingOptions
  Context

Note that the Custom scan type, which can be specified for the Scan command and for the Update Content and Scan command, is not defined in the API. It must be configured in the Symantec Endpoint Protection Manager console.

For more information about the commands that can be run on clients, see the Symantec Endpoint Protection documentation. For basic information about using commands or applying policies to remediate poor client health, see the Integration Guide.

## Member Function Documentation

CommandClientResult com.symantec.sepm.webservice.client.command.CommandService.runClientCommandScan | ( | @WebParam(name="computerGUIDList") String[] | computerGUIDList,
|  | @WebParam(name="scanType") String | scanType
| ) |  | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Runs the Scan command on a specified list of client computers.

Parameters

  computerGUIDList | list of computer GUIDs for client computers on which to run the scan
  scanType | scan type: one of ScanNow_Quick, ScanNow_Full, ScanNow_Custom

Returns
  the CommandClientResult object that provides the commandId of the executed command and any errors

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request

CommandClientResult com.symantec.sepm.webservice.client.command.CommandService.runClientCommandEnableNTP | ( | @WebParam(name="computerGUIDList") String[] | computerGUIDList | ) | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Enables Network Threat Protection on a specified list of client computers.

Parameters

  computerGUIDList | list of computer GUIDs for client computers on which to enable Network Threat Protection

Returns
  the CommandClientResult object that provides the commandId of the executed command and any errors

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request

CommandClientResult com.symantec.sepm.webservice.client.command.CommandService.runClientCommandDisableNTP | ( | @WebParam(name="computerGUIDList") String[] | computerGUIDList,
|  | @WebParam(name="timelimit") long | timeLimit
| ) |  | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Disables Network Threat Protection on a specified list of client computers.

The timeLimit parameter specifies the length of time after which Network Threat Protection is automatically reset to the state that is specified by the policy that is applied to the client. The minimum timeLimit that can be set is one minute, and the maximum is 720 minutes (12 hours). If a timeLimit greater than the maximum is specified, the maximum timeLimit is used.

Note that when the time limit is reached, Network Threat Protection is returned to the state that is specified by the client's policy. For example, the administrator might disable Network Threat Protection on a list of client computers some of which already have it disabled by policy. After the time limit is reached, the Network Threat Protection state that is specified by each client's policy is restored. Based on individual policies, some clients will re-enable Network Threat Protection, and some clients will continue in a disabled state.

Parameters

  computerGUIDList | list of computer GUIDs for client computers on which to disable Network Threat Protection
  timeLimit | time Limit in minutes after which to re-enable Network Threat Protection. Minimum value is 1 and maximum value is 720 (12 hours).

Returns
  the CommandClientResult object that provides the commandId of the executed command and any errors

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request

CommandClientResult com.symantec.sepm.webservice.client.command.CommandService.runClientCommandUpdateContent | ( | @WebParam(name="computerGUIDList") String[] | computerGUIDList | ) | throws ServiceException, InvalidArgumentServiceException, InsufficientAccessServiceException

Runs the Update Content command on a specified list of client computers.

Parameters

  computerGUIDList | list of computer GUIDs for client computers on which to update content

Returns
  the CommandClientResult object that provides the commandId of the executed command and any errors

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request

CommandClientResult com.symantec.sepm.webservice.client.command.CommandService.runClientCommandUpdateContentAndScan | ( | @WebParam(name="computerGUIDList") String[] | computerGUIDList,
|  | @WebParam(name="scanType") String | scanType
| ) |  | throws ServiceException, InvalidArgumentServiceException, InsufficientAccessServiceException

Runs the Update Content and Scan command on a specified list of client computers.

In most cases, we recommend that you update to the latest content before you scan. This command lets you perform both actions with a single command.

Parameters

  computerGUIDList | list of computer GUIDs for client computers on which to update content and run scan
  scanType | update content and scan type ( one of Update_ScanNow_Quick, Update_ScanNow_Full, Update_ScanNow_Custom )

Returns
  the CommandClientResult object that provides the commandId of the executed command and any errors

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request

CommandClientResult com.symantec.sepm.webservice.client.command.CommandService.runClientCommandEnableAP | ( | @WebParam(name="computerGUIDList") String[] | computerGUIDList | ) | throws ServiceException, InvalidArgumentServiceException, InsufficientAccessServiceException

Enables Auto-Protect on a specified list of client computers.

Note that no corresponding command to disable Auto-Protect is available. Auto-Protect is a critical part of endpoint security that should not be disabled.

Parameters

  computerGUIDList | list of computer GUIDs for client computers on which to enable Auto-Protect

Returns
  the CommandClientResult object that provides the commandId of the executed command and any errors

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request

CommandClientResult com.symantec.sepm.webservice.client.command.CommandService.runClientCommandEnableDownloadInsight | ( | @WebParam(name="computerGUIDList") String[] | computerGUIDList | ) | throws ServiceException, InvalidArgumentServiceException, InsufficientAccessServiceException

Enables Download Insight on a specified list of client computers.

Parameters

  computerGUIDList | list of computer GUIDs for client computers on which to enable Download Insight

Returns
  the CommandClientResult object that provides the commandId of the executed command and any errors

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request

CommandClientResult com.symantec.sepm.webservice.client.command.CommandService.runClientCommandDisableDownloadInsight | ( | @WebParam(name="computerGUIDList") String[] | computerGUIDList,
|  | @WebParam(name="timeLimit") long | timeLimit
| ) |  | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Disables Download Insight on a specified list of client computers.

The timeLimit parameter specifies the length of time after which Download Insight is automatically reset to the state that is specified by the policy that is applied to the client. The minimum timeLimit that can be set is one minute, and the maximum is 720 minutes (12 hours). If a timeLimit greater than the maximum is specified, the maximum timeLimit is used.

Note that when the time limit is reached, Download Insight is returned to the state that is specified by the client's policy. For example, the administrator might disable Download Insight on a list of client computers some of which already have it disabled by policy. After the time limit is reached, the Download Insight state that is specified by each client's policy is restored. Based on individual policies, some clients will re-enable Download Insight, and some clients will continue in a disabled state.

Parameters

  computerGUIDList | list of computer GUIDs for client computers on which to disable Download Insight
  timeLimit | time Limit in minutes after which to re-enable Download Insight. Minimum value is 1 and maximum value is 720 (12 hours).

Returns
  the CommandClientResult object that provides the commandId of the executed command and any errors

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request

CommandClientResult com.symantec.sepm.webservice.client.command.CommandService.runClientCommandPowerEraser | ( | @WebParam(name="command") PowerEraserCommand | command | ) | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Runs an individual PowerEraser command on a specified list of client computers or a list of client groups.

This command is intended to detect and remediate threats that are resistant to eradication. The PowerEraser scan command is very aggressive; it can flag critical files, and it can adversely affect client performance. It is typically run on a single computer or small group of computers that cannot be remediated any other way. For more information, see the Symantec Endpoint Protection documentation.

Note that this command differs from the other commands provided by this web service. It takes as its argument a PowerEraserCommand object that specifies individual arguments.

Parameters

  command | the PowerEraserCommand object that specifies the client computers on which to run the command, the individual PowerEraser command to run, and other arguments

Returns
  the CommandClientResult object that provides the commandId of the executed command and any errors

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request

CommandClientResult com.symantec.sepm.webservice.client.command.CommandService.runClientCommandEvidenceOfCompromise | ( | @WebParam(name="command") EvidenceOfCompromiseCommand | command | ) | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Runs an individual Evidence of Compromise (EOC) command on a specified list of client computers or a list of client groups.

This command is used to help detect possible threats that are not reported by the Endpoint Protection client.

Note that this command differs from most of the other commands provided by this web service. It takes as its argument an EvidenceOfCompromiseCommand object that specifies individual arguments.

The CommandClientResult object that is returned from a call to this method includes the content of the result XML.

See also
  CommandStatusDetail.getResultInXML(). This content is stored in the RESULT column of the COMMAND table in the management database. Note that there are constraints on the size of the XML file that can be stored.

Parameters

  command | the EvidenceOfCompromiseCommand object that specifies the client computers on which to run the command and the XML file that lists individual EOC items.

Returns
  the CommandClientResult object that provides the commandId of the executed command and any errors

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request

CommandClientResult com.symantec.sepm.webservice.client.command.CommandService.runClientCommandQuarantine | ( | @WebParam(name="command") QuarantineCommand | command | ) | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Runs an individual Quarantine command on a specified list of client computers or a list of client groups.

You must first assign a Host Integrity policy to the specified clients, and then assign the Quarantine Firewall policy. The command fails if the policies are not assigned.

See also
  PolicyService.assignPolicy() The command may also fail even if the appropriate policies are assigned, if the specified client(s) have not received the policies. This situation can occur in the case where the policies and the command are sent to the client in the same heartbeat. Policy updates can require up to two heartbeats.

Note that this command differs from most of the other commands provided by this web service. It takes as its argument an QuarantineCommand object that specifies individual arguments.

Parameters

  command | the QuarantineCommand object that specifies the client computers on which to run the command.

Returns
  the CommandClientResult object that provides the commandId of the executed command and any errors

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request

CommandStatusDetailResult com.symantec.sepm.webservice.client.command.CommandService.getCommandStatusDetails | ( | @WebParam(name="commandID") String | commandID,
|  | @WebParam(name="pagingOptions") PagingOptions | pagingOptions,
|  | @WebParam(name="context") Context | context
| ) |  | throws InsufficientAccessServiceException, InvalidArgumentServiceException, ServiceException

Gets detailed information about the status of a specified command for all clients on which the command was run.

If the pagingOptions parameter is null, this method uses the default values. The following values are the defaults:

- DEFAULT_PAGE_SIZE (= 100 records)

- SortOrder.ASCENDING

- sortColumn.BeginTime

sortColumn can be one of the following:

- beginTime

- lastUpdateTime

- stateId for the command

See also
  PagingOptions

If the context parameter is null, this method uses the default offset value, 1. Otherwise, this method uses the existing offset value from the context. The updated context object is returned to the caller by the CommandStatusDetailResult object. To retrieve the next set of results, use this updated context object.

See also
  Context

If there is no information to return in the CommandStatusDetailResult object, the fields that the object contains are returned as null values.

Parameters

  commandID | a unique identifier for the command for which the details are to be retrieved
  pagingOptions | object that contains pagination information for returned result sets
  context | (required) object that provides the starting index for multiple sets of results

Returns
  a CommandStatusDetailResult object

See also
  CommandStatusDetailResult
  CommandStatusDetail

Exceptions

  InsufficientAccessServiceException | if the current logged in user does not have sufficient rights to access the endpoint or to execute the web method
  InvalidArgumentServiceException | if the client supplied invalid parameters
  ServiceException | if the web service encountered an error processing the web request

PagingOptions com.symantec.sepm.webservice.client.command.CommandService.createPagingOptions | ( |  | ) |

Creates a PagingOptions object.

This method is provided as a convenience for developers using PowerShell or other scripting languages. It lets the caller create a default object that can be initialized and passed as an input parameter to other web services. Developers who use higher-level languages should be able to create this object directly, or they can use this helper method.

See also
  PagingOptions

Returns
  a new PagingOptions object with values set to their defaults

Implemented in com.symantec.sepm.webservice.client.command.CommandServiceImpl.

Context com.symantec.sepm.webservice.client.command.CommandService.createContext | ( |  | ) |

Creates a Context object.

This method is provided as a convenience for developers using PowerShell or other scripting languages. It lets the caller create a default object that can be initialized and passed as an input parameter to other web services. Developers who use higher-level languages should be able to create this object directly, or they can use this helper method.

See also
  Context

Returns
  a new Context object with values set to their defaults

Implemented in com.symantec.sepm.webservice.client.command.CommandServiceImpl.